@echo off

cls
pushd "%CD%\test"

:System_check64
if exist "%PROGRAMFILES(x86)%" (
set bit2run=64
goto start )

:System_check32
if exist "%PROGRAMFILES%" (
set bit2run=32
goto start )

:start
echo.
type header.jw
set /p target=e.g. the CPU multiplier and FSB (like 333x9 for example): 
echo.
echo The results will be written to x265_1080p-%target%.rtf
echo.
echo This new benchmark uses the latest x265 build 1.4+5 32-bit and 64-bit encoders so 
echo it will better reflect the performance of multi-core processors. It will
echo also be more representative of the performance of the latest x265 encoders.
echo.
echo The benchmark will now encode a 1080p (1920 x 1080) Full HD video sample.
echo. 
echo The benchmark will run 4 times.
echo. 
echo It will take a long time with slower processors, so PLEASE BE PATIENT!
echo.
echo For accurate results, please make sure :
echo    - you do NOT use your PC while the benchmark running!
echo    - you have already closed or disabled as many background apps as possible.
echo.

:bitrunchoice
if "%bit2run%"=="64" (
echo.
echo Detected 64-bit operating system. Do you want to run the benchmark in:
echo   1. 32-bit
echo             or
echo   2. 64-bit
CHOICE /N /C:12 [Select 1 or 2] %1
REM - THE NEXT THREE LINES ARE DIRECTING USER DEPENDING UPON INPUT
IF ERRORLEVEL ==2 GOTO 64_bit
IF ERRORLEVEL ==1 GOTO 32_bit
)

:32_bit
set bit2run=32
goto run1

:64_bit
set bit2run=64
goto run1

:run1
echo.
echo    --- Now Starting %bit2run%-bit Run 1
echo.
ffmpeg -loglevel warning -i "test-1080p.mkv" -f rawvideo - | start /high /b x265-%bit2run% - --input-res 1920x1080 --fps 23.976 --output "../run1-1080p.hevc" --crf 20 --preset fast 2>&1 | tee run1crf.log

:run2
echo.
echo    --- Now Starting %bit2run%-bit Run 2
echo.
ffmpeg -loglevel warning -i "test-1080p.mkv" -f rawvideo - | start /high /b x265-%bit2run% - --input-res 1920x1080 --fps 23.976 --output "../run2-1080p.hevc" --crf 20 --preset fast 2>&1 | tee run2crf.log

:run3
echo.
echo    --- Now Starting %bit2run%-bit Run 3
echo.
ffmpeg -loglevel warning -i "test-1080p.mkv" -f rawvideo - | start /high /b x265-%bit2run% - --input-res 1920x1080 --fps 23.976 --output "../run3-1080p.hevc" --crf 20 --preset fast 2>&1 | tee run3crf.log

:run4
echo.
echo    --- Now Starting %bit2run%-bit Run 4
echo.
ffmpeg -loglevel warning -i "test-1080p.mkv" -f rawvideo - | start /high /b x265-%bit2run% - --input-res 1920x1080 --fps 23.976 --output "../run4-1080p.hevc" --crf 20 --preset fast 2>&1 | tee run4crf.log

:cpuzdetails
REM Load CPU-Z while SpeedStep is off to accurately report the CPU multiplier
start /b cpuz -txt=system_details

:waitcpuz
if not exist system_details.txt (
ping 127.0.0.1 -n 10 -w 1000 >NUL 2>&1
goto waitcpuz
)

:analyze-new
echo x265 HD BENCHMARK 0.1.4 RESULTS >> "x265_1080p-%target%.rtf"
echo. >> "x265_1080p-%target%.rtf"
echo Please do NOT compare it with older versions of the benchmark! >> "x265_1080p-%target%.rtf"
echo.
echo Please copy/paste everything below the line to to report your >> "x265_1080p-%target%.rtf"
echo data to http://x265.ru/x265-hd-benchmark/ >> "x265_1080p-%target%.rtf"
echo. >> "x265_1080p-%target%.rtf"
echo ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ >> "x265_1080p-%target%.rtf"
echo Results for x265.exe build 1.4+5 >> "x265_1080p-%target%.rtf"
echo x265 Benchmark: %bit2run%-bit >> "x265_1080p-%target%.rtf"
echo ========================== >> "x265_1080p-%target%.rtf"
echo. >> "x265_1080p-%target%.rtf"
echo CRF-20 preset-"fast" >> "x265_1080p-%target%.rtf"
echo -------------------- >> "x265_1080p-%target%.rtf"
grep -U -s "encoded" run1crf.log >> "x265_1080p-%target%.rtf"
grep -U -s "encoded" run2crf.log >> "x265_1080p-%target%.rtf"
grep -U -s "encoded" run3crf.log >> "x265_1080p-%target%.rtf"
grep -U -s "encoded" run4crf.log >> "x265_1080p-%target%.rtf"
echo. >> "x265_1080p-%target%.rtf"

:end
REM Insert system info into report

echo. >> "x265_1080p-%target%.rtf"
echo System Details >> "x265_1080p-%target%.rtf"
echo -------------- >> "x265_1080p-%target%.rtf"
grep -U -s "Name			Intel" "%CD%\system_details.txt" >> "x265_1080p-%target%.rtf"
grep -U -s "Name			AMD" "%CD%\system_details.txt" >> "x265_1080p-%target%.rtf"
grep -U -s "Codename" "%CD%\system_details.txt" >> "x265_1080p-%target%.rtf"
grep -U -s "Specification" "%CD%\system_details.txt" >> "x265_1080p-%target%.rtf"
grep -U -s "Core Stepping" "%CD%\system_details.txt" >> "x265_1080p-%target%.rtf"
grep -U -s "Technology" "%CD%\system_details.txt" >> "x265_1080p-%target%.rtf"
grep -U -s "Stock frequency" "%CD%\system_details.txt" >> "x265_1080p-%target%.rtf"
grep -U -s "Core Speed" "%CD%\system_details.txt" >> "x265_1080p-%target%.rtf"
grep -U -s "FID range" "%CD%\system_details.txt" >> "x265_1080p-%target%.rtf"
echo. >> "x265_1080p-%target%.rtf"
grep -U -s "Northbridge" "%CD%\system_details.txt" >> "x265_1080p-%target%.rtf"
grep -U -s "Southbridge" "%CD%\system_details.txt" >> "x265_1080p-%target%.rtf"
echo. >> "x265_1080p-%target%.rtf"
grep -U -s "CAS#" "%CD%\system_details.txt" >> "x265_1080p-%target%.rtf"
grep -U -s "RAS# Precharge" "%CD%\system_details.txt" >> "x265_1080p-%target%.rtf"
grep -U -s "Cycle Time (tRAS)" "%CD%\system_details.txt" >> "x265_1080p-%target%.rtf"
grep -U -s "Command Rate" "%CD%\system_details.txt" >> "x265_1080p-%target%.rtf"
grep -U -s "Memory Frequency" "%CD%\system_details.txt" >> "x265_1080p-%target%.rtf"
grep -U -s "Memory Type" "%CD%\system_details.txt" >> "x265_1080p-%target%.rtf"
grep -U -s "Memory Size" "%CD%\system_details.txt" >> "x265_1080p-%target%.rtf"
grep -U -s "Channels" "%CD%\system_details.txt" >> "x265_1080p-%target%.rtf"
echo. >> "x265_1080p-%target%.rtf"
grep -U -s "Windows Version" "%CD%\system_details.txt" >> "x265_1080p-%target%.rtf"
echo. >> "x265_1080p-%target%.rtf"
grep -U -s "max VID" "%CD%\system_details.txt" >> "x265_1080p-%target%.rtf"
grep -U -s "Voltage sensor 0" "%CD%\system_details.txt" >> "x265_1080p-%target%.rtf"
grep -U -s "Number of processors" "%CD%\system_details.txt" >> "x265_1080p-%target%.rtf"
grep -U -s "Number of threads" "%CD%\system_details.txt" >> "x265_1080p-%target%.rtf"
grep -U -s "L2 cache" "%CD%\system_details.txt" >> "x265_1080p-%target%.rtf"
grep -U -s "Instructions sets" "%CD%\system_details.txt" >> "x265_1080p-%target%.rtf"
grep -U -s "Package" "%CD%\system_details.txt" >> "x265_1080p-%target%.rtf"
echo. >> "x265_1080p-%target%.rtf"
grep -U -s "Temperature" "%CD%\system_details.txt" >> "x265_1080p-%target%.rtf"

ping 127.0.0.1 -n 4 -w 1000 >NUL 2>&1
move "x265_1080p-%target%.rtf" .. >NUL 2>&1

:clean-up
del *.txt >NUL 2>&1
del *.log >NUL 2>&1
del ..\*.hevc >NUL 2>&1

:publish-new
echo.
echo All runs complete!
echo.
echo Data written to x265_1080p-%target%.rtf
echo.
set /p target=Hit the ENTER key to close this window and open your report!
start /b wordpad "../x265_1080p-%target%.rtf"



:exit
